using System;
using System.Text;
using System.Data;

namespace VDRGUI
{
/// <summary>
/// Hier werden die eigentlichen HTML Quelltexte generiert - also die Templates interpretiert, verndert
/// und an den User geschickt
/// </summary>
	public class WebApplication
	{
		private EPGData VDR_Daten;

		/// <summary>
		/// Konstruktor der WebApplication Klasse
		/// </summary>
		/// <param name="Data">die initialisierte EPG Daten-Klasse</param>
		public WebApplication(EPGData Data)
		{
			VDR_Daten = Data;
		}

		/// <summary>
		/// Bearbeitet die HTTP Useranfrage und erzeugt die HTML Seiten die der User angezeigt bekommt
		/// </summary>
		/// <param name="UserRequest">Request des Users</param>
		/// <returns>HTML Quelltext-Antwort fr den User</returns>
		public string process_request(string UserRequest)
		{
			string HTMLSource = "";

			// ersten Slash entfernen
			if (UserRequest.StartsWith("/")) 
				UserRequest = UserRequest.Remove(0,1);
			string[] splittet = UserRequest.Split(' ');

			if (splittet.Length >= 1)
			{
				switch(splittet[0])
				{
					case "whatsontv":
						Console.WriteLine("Web-Application: Whats-On-Tv\n");
						HTMLSource = WhatsOnTvNow();
						break;

				}
			}
			return HTMLSource;
		}

		/// <summary>
		/// Erzeugt eine "Was luft gerade" Tabelle mit allen Sendern
		/// </summary>
		/// <returns>"Was luft gerade" Tabelle als HTML Quelltext</returns>
		public string WhatsOnTvNow()
		{
			StringBuilder output = new StringBuilder();
			foreach (DataRow dr in VDR_Daten.channel.Rows)
			{
				output.Append("Sender: "+dr["channel_name"].ToString()+"<br>");
				foreach (DataRow dr2 in dr.GetChildRows("channelepgData"))
				{
					DateTime tempDate = (DateTime)dr2["event_start"];

					output.Append(tempDate.ToString()+"<p>");

					output.Append(dr2["event_title"].ToString()+"<p>");
				}
			}
			return output.ToString();
		}

	}
}
